/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.94 by jmc, Thu Sep 6 22:31:45 2007 UTC revision 1.125 by jmc, Tue May 12 18:44:24 2009 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
26      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 27  usage() Line 30  usage()
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
# Line 64  usage() Line 68  usage()
68  build_mpack()  build_mpack()
69  {  {
70      printf "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74              echo              echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 73  build_mpack() Line 78  build_mpack()
78              echo              echo
79              HAVE_MPACK=f              HAVE_MPACK=f
80          fi          fi
         printf "building mpack...  "  
81          if test "x$CC" = x ; then          if test "x$CC" = x ; then
82              export CC=cc              export CC=cc
83          fi          fi
84            printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 87  build_mpack() Line 92  build_mpack()
92          else          else
93              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
94              HAVE_MPACK=t              HAVE_MPACK=t
95                echo "done"
96          fi          fi
97      else      else
98          HAVE_MPACK=t          HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
101  }  }
102    
103  testoutput_var()  testoutput_var()
104  {  {
105      # testoutput_var dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
106      #      #
107      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
108      #     with same output from reference file $dir/results/output.$extension      #     with same output from reference file $dir/results/$reference_output
109      #  using search strings s1 and text label      #  using search strings s1 and text label
110    
111      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
# Line 108  testoutput_var() Line 114  testoutput_var()
114      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
115          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
116          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
117          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
118              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
119                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
120              fi              fi
# Line 119  testoutput_var() Line 125  testoutput_var()
125          return 99          return 99
126      fi      fi
127      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
128          echo testoutput_var: grep "$2" $1/results/output.$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
129      fi      fi
130      grep "$2" $1/results/output.$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
131      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
132      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
133          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
134              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
135          fi          fi
# Line 161  testoutput_var() Line 167  testoutput_var()
167      digits_of_similarity=`./tr_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
168      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo testoutput_var: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
171          fi          fi
172          digits_of_similarity=99          digits_of_similarity=99
173      else      else
174          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
175              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
176          fi          fi
177      fi      fi
178      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 174  testoutput_var() Line 180  testoutput_var()
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tr_cmpnum < t5.txt`  
     digits_6=`./tr_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
183  testoutput_run()  testoutput_run()
184  {  {
185      # testoutput_run directory subdir extension      # testoutput_run directory subdir reference_output
186      #      #
187      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
188      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
189          # default list of output variables to be checked:          # default list of output variables to be checked:
190          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
191          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
192          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
         nbDef=`echo $listChk | awk '{print NF-1+3*gsub("+","E")}'`  
193          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
194          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
195          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
196          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
197          listVar=`echo $listChk | awk '{ for(i=2;i<=NF;i++){if (sub("+","",$i)) \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198              {printf " %s %s %s %s",$i"mn",$i"mx",$i"av",$i"sd"} else {printf " %s",$i} }}'`                                 | sed 's/+//g' | sed "s/^$sVar//"`
199          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200          for ii in 1 2 3 4 5 6 7 8 9 ; do          # check for ptracer output in reference_output file :
201            tst=`eval 'echo "$HAVE_PTR0'$ii'"'`          outpref=$1/results/$3
202           #echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203            if test "x$tst" != xt ; then listVar=`echo "$listVar" | sed "s/ pt$ii..//g"` ; fi          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
204          done          for ii in $PTRACERS_NUM ; do
205          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){t+=($i==$1)}; print t }'`              ptrfound=0
206                for jj in $ptr_mon ; do
207                    name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208                    tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209                    if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210                done
211                if test $ptrfound = '1' ; then
212                    eval "HAVE_PTR0"$ii"=t"
213                else
214                    eval "HAVE_PTR0"$ii"=f"
215                  if test "x$ADM" = x -a "x$OADM" = x; then
216                  # remove this ptr from the list of output variable to check
217                  # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                    listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  fi
220                fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222            done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224          if test $tst != 1 ; then          if test $tst != 1 ; then
225            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
# Line 269  testoutput_run() Line 236  testoutput_run()
236            case $xx in            case $xx in
237             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
238                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
239                    testoutput_var $1 "cg2d_init_res" "cg2d init. residual" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
240                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
241             'Tmn') testoutput_var $1 "dynstat_theta_min"  "theta minimum"  $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
242             'Tmx') testoutput_var $1 "dynstat_theta_max"  "theta maximum"  $2 $3; yy=$? ;;            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
243             'Tav') testoutput_var $1 "dynstat_theta_mean" "theta mean"     $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
244             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "theta s.d."     $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
245             'Smn') testoutput_var $1 "dynstat_salt_min"  "salt minimum"    $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
246             'Smx') testoutput_var $1 "dynstat_salt_max"  "salt maximum"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
247             'Sav') testoutput_var $1 "dynstat_salt_mean" "salt mean"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
248             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "salt s.d."       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
249               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
250               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
251             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
252             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
253             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
254             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U s.d."          $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
255             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
256             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
257             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
258             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V s.d."          $2 $3; yy=$? ;;             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
259          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
260             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
261          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
# Line 294  testoutput_run() Line 263  testoutput_run()
263          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_sd"    $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
270             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
277             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
278             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
279            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
282            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
283            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
284            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
285                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
286            esac            esac
287            if test $xx = $sVar            if test $xx = $sVar
# Line 304  testoutput_run() Line 291  testoutput_run()
291          done          done
292    
293          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
294          if [ $nbVar -lt $nbDef ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
295          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
296            adNul=`expr $nbDef - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
297            echo $allargs $adNul            echo $allargs $adNul
298          else          else
299            echo $allargs            echo $allargs
300          fi          fi
301    # <-- same processing for adjoint & forward test
     else  
         testoutput_ad $1 $2 "precision_grdchk_result"  
     fi  
302  }  }
303    
304  genmakemodel()  genmakemodel()
# Line 331  genmakemodel() Line 315  genmakemodel()
315          (          (
316              cd $1;              cd $1;
317              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
318              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
319                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
320                elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324              fi              fi
325              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
326                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
327              fi              fi
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
335                  command="$command -mpi"                  command="$command -mpi"
336              fi              fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
342                  command="$command -ts"                  command="$command -ts"
343              fi              fi
# Line 356  genmakemodel() Line 349  genmakemodel()
349              fi              fi
350              fi              fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              $command > make.log 2>&1              # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
356              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
# Line 414  run_clean() Line 408  run_clean()
408              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
409              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
410              rm -rf mnc_test_*              rm -rf mnc_test_*
411                rm -f *_MIT_CE_000.opt0000 costfunction*0000
412              echo successful 1>&2              echo successful 1>&2
413              exit 0              exit 0
414          )          )
# Line 450  makemodel() Line 445  makemodel()
445          cd $1;          cd $1;
446          if test -r Makefile ; then          if test -r Makefile ; then
447              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
448              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
449                    $MAKE adall >> make.log 2>&1
450                elif test "x$OADM" = xt ; then
451                    $MAKE adAll >> make.log 2>&1
452                else
453                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
454                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
455                  else                  else
456                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
457                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
458              fi              fi
459              RETVAL=$?              RETVAL=$?
460              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
# Line 484  symlink_mpifiles() Line 481  symlink_mpifiles()
481      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
482            
483      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
484      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
485    
486      #  Is this an MPI run?      #  Is this an MPI run?
487      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 528  linkdata() Line 525  linkdata()
525      if test -d $1 ; then      if test -d $1 ; then
526          (          (
527              cd $1 ; shift              cd $1 ; shift
528                inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
529                for xx in $inpMPI ; do
530                  if test -r "../"$1"/"$xx ; then
531                    # found 1 _mpi sfx file in 1rst input dir and it is readable
532                    yy=`echo $xx | sed 's:\.mpi$::'`
533                    if test "x$MPI" = "xt" ; then
534                    # mpi test: remove symbolic link & link _mpi sfx file
535                        if test -h $yy ; then rm -f $yy ; fi
536                        if test ! -r $yy ; then
537                            ln -sf "../"$1"/"$xx $yy ;
538                            printf "$xx " 1>&2
539                        fi
540                    else
541                    # not mpi test: remove symbolic link
542                        if test -h $yy ; then rm -f $yy ; fi
543                    fi
544                  fi
545                done
546              if test -r "../"$1"/eedata.mth" ; then              if test -r "../"$1"/eedata.mth" ; then
547              # found eedata.mth in 1rst input dir and it is readable              # found eedata.mth in 1rst input dir and it is readable
548                  if test "x$MULTI_THREAD" = "xt" ; then                  if test "x$MULTI_THREAD" = "xt" ; then
# Line 542  linkdata() Line 557  linkdata()
557                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
558                  fi                  fi
559              fi              fi
560                prevDir='NONE'
561              for ldir in $* ; do              for ldir in $* ; do
562                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
563                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
564                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
565                      for i in $files ; do                      for i in $files ; do
# Line 559  linkdata() Line 575  linkdata()
575                      fi                      fi
576                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
577                  fi                  fi
578                    prevDir=$ldir
579              done              done
580          )          )
581      fi      fi
# Line 575  runmodel() Line 592  runmodel()
592          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
593          # make output.txt          # make output.txt
594          echo          echo
595            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
596                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
597                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
598            fi
599          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
600              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
601              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
602          fi          fi
603          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
604                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
605                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
606                  echo " no executable:" $EXECUTABLE >> run.log                  echo " no executable:" $EXECUTABLE >> $RUNLOG
607                  RETVAL=8                  RETVAL=8
608                  ENDVAL=-1                  ENDVAL=-1
609          else          else
610              if test $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
611                  rm -f run.log ; touch run.log                # output do not exist or is older than executable:
612                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  rm -f $RUNLOG ; touch $RUNLOG
613                  ( eval $COMMAND ) >> run.log 2>&1                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
614                    ( eval $COMMAND ) >> $RUNLOG 2>&1
615                  RETVAL=$?                  RETVAL=$?
616              else              else
617                  RETVAL=0                  RETVAL=0
618                  if test -f run.log ; then                  if test -f $RUNLOG ; then
619                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
620                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
621                  else                  else
622                      touch run.log                      touch $RUNLOG
623                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
624                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
625                      echo " no previous run.log: assume NORMAL END" >> run.log 2>&1                      echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
626                  fi                  fi
627              fi              fi
628              ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
629          fi          fi
630          rm -f run.log_00          rm -f run.log_tmp
631          #if test "x$RETVAL" = x0 ; then          #if test "x$RETVAL" = x0 ; then
632          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
633              tail run.log              tail $RUNLOG
634              echo successful 1>&2              echo successful 1>&2
635              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
636              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
637              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
638              return 0              return 0
639          else          else
640              tail run.log              tail $RUNLOG
641              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
642              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
643              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
644              return 1              return 1
645          fi          fi
# Line 628  createcodelet() Line 650  createcodelet()
650  {  {
651      # create codelet for comparing model output      # create codelet for comparing model output
652    
653      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
654      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
655  #include <stdio.h>  #include <stdio.h>
656  #include <math.h>  #include <math.h>
# Line 637  int main( int argc, char** argv )  { Line 659  int main( int argc, char** argv )  {
659    double a,b,abave,relerr;    double a,b,abave,relerr;
660    best = -22;    best = -22;
661    lncnt = 0;    lncnt = 0;
662    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
663      scanf("%d", &linnum);      scanf("%d", &linnum);
664      if (linnum == -1)  break;      if (linnum == -1)  break;
665      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
# Line 684  formatresults() Line 706  formatresults()
706      listPrt=$@      listPrt=$@
707      listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`      listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
708      xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`      xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
709      printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'      printf '%3s' $listPrt
710  #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > / /' | sed 's/  < / /'  #   line below does not work on hp-ux_ia64 : do those substitutions later on
711    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
712            
713      if [ $xx = '..' ]; then      if [ $xx = '..' ]; then
714          printf ' N/O '          printf ' N/O '
# Line 709  scandirs() Line 732  scandirs()
732  {  {
733      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
734          for arg in * ; do          for arg in * ; do
735              test -d $arg/$1 && echo $arg              test -f $arg/$1 && echo $arg
736          done          done
737      else      else
738          echo $*          echo $*
# Line 717  scandirs() Line 740  scandirs()
740  }  }
741    
742    
743    check_eedata()
744    {
745        # check_eedata size.h eedata
746        if [ $# -eq 2 ] ; then
747          if test -f $1 -a -f $2 ; then
748          sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
749          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
750          if test "x$nx" = x ; then
751            rx=10
752          else
753            rx=`expr $sx % $nx`
754          fi
755          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
756          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
757          if test "x$ny" = x ; then
758            ry=20
759          else
760            ry=`expr $sy % $ny`
761          fi
762          echo `expr $rx + $ry`
763        else
764          echo '-1'
765          fi
766        else
767          echo '-2'
768        fi
769    
770    }
771    
772  ###############################################################################  ###############################################################################
773    
774    
# Line 724  scandirs() Line 776  scandirs()
776  debug=0  debug=0
777  verbose=1  verbose=1
778  clean=0  clean=0
 expts=''  
 # ieee=1  
779    
780  IEEE=true  IEEE=true
781  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
782      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
783  fi  fi
784    GSL=f
785    
786  CLEANUP=f  CLEANUP=f
787  QUICK=f  QUICK=f
# Line 747  TESTDIRS= Line 797  TESTDIRS=
797  SKIPDIRS=  SKIPDIRS=
798  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
799  HAVE_MPACK=  HAVE_MPACK=
800  MPACK="$MPACKDIR/mpack"  MPACK=
801  COMMAND=  COMMAND=
802  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
803      MAKE=make      MAKE=make
# Line 762  OUTDIR= Line 812  OUTDIR=
812  DELDIR=  DELDIR=
813    
814  ADM=  ADM=
815    OADM=
816    
817  # Additional monitor types  # list of pTracers to check for monitor output
818  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
819    
820  MATCH_CRIT=13  MATCH_CRIT=13
# Line 796  for ac_option ; do Line 847  for ac_option ; do
847              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
848          -addr=* | --addr=*)          -addr=* | --addr=*)
849              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
850            -mpackdir | --mpackdir | -mpd | --mpd)
851                ac_prev=MPACKDIR ;;
852            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
853                MPACKDIR=$ac_optarg ;;
854    
855          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
856              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
# Line 859  for ac_option ; do Line 914  for ac_option ; do
914    
915          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
916    
917            -oad) OADM=t; NODEPEND=t ;;
918    
919          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
920          -noieee) IEEE= ;;          -noieee) IEEE= ;;
921            -gsl) GSL=t ;;
922    
923          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
924          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 894  if test "x$QUICK" = xt ; then Line 952  if test "x$QUICK" = xt ; then
952      NODEPEND=t      NODEPEND=t
953  fi  fi
954    
955    #- setting for forward or ADM testing
956    if test "x$ADM" = xt ; then
957        code_dir=code_ad
958        inputdir=input_ad
959        ref_outp="output_adm.txt"
960        EXECUTABLE="mitgcmuv_ad"
961    elif test "x$OADM" = xt ; then
962        code_dir=code_oad
963        inputdir=input_oad
964        ref_outp="output_oadm.txt"
965        EXECUTABLE="mitgcmuv_ad"
966    else
967        code_dir=code
968        inputdir=input
969        ref_outp="output.txt"
970        EXECUTABLE="mitgcmuv"
971    fi
972    
973  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
974      if test "x$ADM" = xt ; then      LIST=`scandirs results/$ref_outp`
         LIST=`scandirs results_ad`  
     else  
         LIST=`scandirs results`  
     fi  
975  else  else
976      #- expand group of experiments:      #- expand group of experiments:
977      LIST=" "      LIST=" "
# Line 943  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 1015  if test "x$OPTFILE" = xNONE -a "x$MITGCM
1015      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1016  fi  fi
1017    
1018  if test "x$ADM" = xt ; then  RUNLOG="run.log"
1019      EXECUTABLE="mitgcmuv_ad"  OUTPUTFILE=$ref_outp
     OUTPUTFILE="output_adm.txt"  
 else  
     EXECUTABLE="mitgcmuv"  
     OUTPUTFILE="output.txt"  
 fi  
   
1020  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1021      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1022  fi  fi
# Line 958  if test "x$MPI" = xt ; then Line 1024  if test "x$MPI" = xt ; then
1024      OUTPUTFILE="STDOUT.0000"      OUTPUTFILE="STDOUT.0000"
1025  fi  fi
1026    
 #echo "OK"  
1027  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
1028    
1029  # set the Default List of output variables to be checked:  # set the Default List of output variables to be checked:
1030  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1031  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1032  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1033  if test "x$ADM" != xt ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1034      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1035      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1036      nbDef=`echo $DEF_CHECK_LIST | awk '{print NF-1+3*gsub("+","E")}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1037      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1038      EMPTY_RESULTS=$EMPTY_RESULTS`expr $nbDef - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1039    else
1040        DEF_CHECK_LIST='Grad Cost Grad'
1041        EMPTY_RESULTS='.. ..'
1042        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1043  fi  fi
1044    
1045  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1046  createcodelet  createcodelet
1047    
1048  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1049  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1050      echo "skipping mpack build"      echo "skipping mpack build"
1051  else  else
1052      build_mpack      build_mpack
1053  fi  fi
1054    
1055  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1056    CMDLINE=$0
1057    for xx in "$@" ; do nw=`echo $xx | wc -w`
1058        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1059                            else CMDLINE="$CMDLINE '$xx'" ; fi
1060    done
1061    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1062  MACH=`hostname`  MACH=`hostname`
1063  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1064  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1065  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1066  if test "x$OUTDIR" != x ; then  if test "x$OUTDIR" != x ; then
1067      BASE="tr_"$OUTDIR"_"$DATE"_"      BASE="tr_"$OUTDIR"_"$DATE"_"
1068    else
1069        short_name=`hostname | sed 's/\..*$//'`
1070        BASE="tr_"$short_name"_"$DATE"_"
1071  fi  fi
1072  DNUM=0  DNUM=0
1073  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
# Line 1004  if test "x$RETVAL" != x0 ; then Line 1082  if test "x$RETVAL" != x0 ; then
1082      exit 1      exit 1
1083  fi  fi
1084  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1085  start_date=`date`  start_date=`date`
1086  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1087    echo 'run:' $CMDLINE >> $SUMMARY
1088    echo 'on :' $UNAMEA  >> $SUMMARY
1089    
1090  of_path=  of_path=
1091  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 1035  else Line 1114  else
1114  fi  fi
1115  echo  echo
1116  echo >> $SUMMARY  echo >> $SUMMARY
1117  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1118      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1119      then line_0="default  "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1120      else line_0="default "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
# Line 1046  if test "x$ADM" = x ; then Line 1125  if test "x$ADM" = x ; then
1125      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1126      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1127      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1128          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1129          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1130          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1131          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1132          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1133      done      done
1134      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1135      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 1064  if test "x$ADM" = x ; then Line 1140  if test "x$ADM" = x ; then
1140  else  else
1141      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1142      echo >> $SUMMARY      echo >> $SUMMARY
1143        if [ $MATCH_CRIT -lt 10 ] ;
1144        then line_0="default     "$MATCH_CRIT ;
1145        else line_0="default    "$MATCH_CRIT ; fi
1146        echo "$line_0" | tee -a $SUMMARY
1147      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1148  G D M    C  G  G D M    C  G
1149  E p a R  o  r  E p a R  o  r
# Line 1076  fi Line 1156  fi
1156  #  ...and each test directory...  #  ...and each test directory...
1157  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1158            
1159        # set builddir & rundir:
1160        builddir="build"
1161        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1162        rundir="run"
1163        if test ! -d $dir/$rundir ; then
1164            rundir=$builddir
1165        fi
1166        CODE_DIR=$dir/$code_dir
1167        BUILD_DIR=$dir/$builddir
1168    
1169      #  Cleanup only!      #  Cleanup only!
1170      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1171          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1172              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/$builddir
1173              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1174          fi          fi
1175          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1176              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1177              run_clean $dir/run              run_clean $dir/$rundir
1178          fi          fi
1179          (          (
1180              cd $dir              cd $dir
# Line 1095  for dir in $TESTDIRS ; do Line 1185  for dir in $TESTDIRS ; do
1185    
1186      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1187      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1188      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output_adm.txt"  
     fi  
1189      if test ! -r $fout ; then      if test ! -r $fout ; then
1190          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1191          continue          continue
1192      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
1193    
1194      # Check for additional types of monitor output      # Check for specific files for particular type of run
   
     builddir="build"  
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
    #rundir=$builddir  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
       
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
         input_dirs='input'  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
         input_dirs='input_ad input'  
     fi  
     BUILD_DIR=$dir/$builddir  
1195    
1196      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1197          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
# Line 1138  for dir in $TESTDIRS ; do Line 1201  for dir in $TESTDIRS ; do
1201          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1202          continue          continue
1203      fi      fi
1204        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1205          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1206          if test $retv != 0 ; then
1207            echo "input/eedata.mth tiling misfit -- skipping $dir"
1208            continue
1209          fi
1210        fi
1211    
1212      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1213      extra_runs=      extra_runs=
1214      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1215          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1216          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1217          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1218              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1219              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1220              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1221                  if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1222                      if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1223                          extra_runs="$extra_runs $name"                if test "x$MPI" = "xt" ; then
1224                      #else echo $dir"/"$exd"/eedata.mth: not found"                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1225                      fi                  if test $retv = 0 ; then
                 else  
1226                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1227                    else
1228                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1229                  fi                  fi
1230                  else
1231                    extra_runs="$extra_runs $name"
1232                  fi
1233                #else echo $dir"/"$exd"/eedata.mth: not found"
1234              fi              fi
1235          done            else
1236      fi              extra_runs="$extra_runs $name"
1237              fi
1238            fi
1239        done
1240    
1241      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1242      echo      echo
# Line 1187  for dir in $TESTDIRS ; do Line 1265  for dir in $TESTDIRS ; do
1265              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1266              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1267              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1268              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1269              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1270              && results=`testoutput_run $dir $rundir "txt"`              && results=`testoutput_run $dir $rundir $ref_outp`
1271      fi      fi
1272            
1273      echo      echo
     if test "x$ADM" = x ; then  
1274          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1275          echo          echo
1276          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1277          touch $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1278          echo "fresults='$fres'" >> $CDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1279          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1280          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1281          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1282          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1283            if test "x$ADM" = xt ; then
1284                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1285                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1286                                    >> $CDIR"/summary.txt"
1287            fi
1288    
1289          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1290              unset run              unset run
1291              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1292                #  reference output file
1293                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1294              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1295              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1296              mkdir $rel_CDIR              mkdir $rel_CDIR
1297              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1298              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1299              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1300              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1301              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1302                  && results=`testoutput_run $dir tr_run.$ex ${ex}".txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1303              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1304              fres="$fres.$ex"              fres="$fres.$ex"
1305              echo              echo
1306              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1307              touch $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1308              echo "fresults='$fres'" >> $CDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1309              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1310              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1311              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1312              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1313                if test "x$ADM" = xt ; then
1314                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1315                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1316                                       >> $CDIR"/summary.txt"
1317                fi
1318              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1319                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1320              fi              fi
1321          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         touch $CDIR"/summary.txt"  
         echo "fresults='$fres'" >> $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1322    
1323      #postclean $dir/$builddir      #postclean $dir/$builddir
1324      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1257  for dir in $TESTDIRS ; do Line 1331  for dir in $TESTDIRS ; do
1331  done  done
1332    
1333  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1334  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1335  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1336  date >> $SUMMARY  date >> $SUMMARY
1337    
# Line 1291  fi Line 1365  fi
1365  rm -f tr_cmpnum.c tr_cmpnum  rm -f tr_cmpnum.c tr_cmpnum
1366    
1367  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1368      cat $SUMMARY | sed 's/  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.//'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
 #   cat $SUMMARY | sed 's/  \.//g'  
1369      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1370          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1371      fi      fi
1372      cat $SUMMARY | sed 's/  \.//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1373  fi  fi
1374    
1375  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.94  
changed lines
  Added in v.1.125

  ViewVC Help
Powered by ViewVC 1.1.22